(function($){
	var PasswordStrength = function(options){
        var root = this;
		this.vars = {
                container: null,										//target password element
                meter: null,											//meter element
                metertext: null,										//meter text element
                metervalue: null,										//percentage of meter shown
        		useText: true,											//Use text with the meter
        		minLength: 6,											//Minimum password length
        		maxLength: 15,											//Maximum password length
        		poorClass: 'progress progress-danger',					//The class for a bad password element
        		weakClass: 'progress progress-warning',					//The class for a weak password element
        		mediumClass: 'progress progress-info',					//The class for a medium password element
        		strongClass: 'progress progress-success',				//The class for a strong password element
        		defaultstrength: 1,										//use joomla strength requirements
        		minlength: 4,
        		minintegers: 0,
        		minsymbols: 0,
        		minuppercase: 0,
        		weakRegEx: '([a-z]{1}[A-Z]{1})|([A-Z]{1}[a-z]{1})[^\s]',//The regex to be passed for the password to be weak
        		mediumRegEx: '[0-9]{1}',								//The regex to be passed for the password to be medium
        		strongRegEx: '[^a-zA-Z0-9]{1}'							//The regex to be passed for the password to be strong
        };
		var construct = function(options){
			Object.assign(root.vars,options);
			root.vars.meter = $('<div class="'+root.vars.weakClass+'"/>')
			.css({
				width:$(root.vars.container).outerWidth(),
				position:'relative'
			})
			.appendTo($(root.vars.container).parent());
			if(root.vars.useText) {
				root.vars.metertext = $('<div class="metertext"/>')
				.css({
					position: 'absolute',
					width: '100%',
					'text-align':'center'
				})
				.text(Joomla.JText._('PLG_USER_PASSWORDSTRENGTH_TEXT_WEAK'))
				.appendTo(root.vars.meter);
			}
			root.vars.metervalue = $('<div class="bar" width="0%"/>').appendTo(root.vars.meter);
			$(root.vars.container).on('keyup',function(){
				var value = $(this).val().trim();
				if(root.vars.defaultstrength) {
					$req = 0;
					$met = 0;
					if(root.vars.minlength) {
						$req++;
						if(value.length >= root.vars.minlength){
							$met++
						}
					}
					if(root.vars.minintegers) {
						$req++;
						var match = value.match(/\d/g);
						if(match && match.length >= root.vars.minintegers) {
							$met++;
						}
					}
					if(root.vars.minsymbols) {
						$req++;
						var match = value.match(/[^A-Za-z0-9]/g);
						if(match && match.length >= root.vars.minsymbols) {
							$met++;
						}
					}
					if(root.vars.minuppercase) {
						$req++;
						var match = value.match(/[A-Z]/g);
						if(match && match.length >= root.vars.minuppercase) {
							$met++;
						}
					}
					$level = $met/$req;
					if($level == 1) {
						root.changeMeter('strong');
					} else {
						if($level >= 0.75) {
							root.changeMeter('medium');
						} else {
							if($level >= 0.5) {
								root.changeMeter('weak');
							} else {
								root.changeMeter('poor');
							}
						}
					}
				} else {
					var weakRegEx = new RegExp(root.vars.weakRegEx);
					var mediumRegEx = new RegExp(root.vars.mediumRegEx);
					var strongRegEx = new RegExp(root.vars.strongRegEx);
					if ((value.length >= root.vars.minLength) && (value.length < root.vars.maxLength) && ((weakRegEx.test(value))||(mediumRegEx.test(value))||(strongRegEx.test(value)))){ //If the password entered is in range and has met at least one of the regexes
						if (((mediumRegEx.test(value))&&(weakRegEx.test(value)))||((strongRegEx.test(value))&&(weakRegEx.test(value)))||((strongRegEx.test(value))&&(mediumRegEx.test(value)))){ //If the password entered has met at least two of the regexes
							if ((strongRegEx.test(value))&&(mediumRegEx.test(value))&&(weakRegEx.test(value))){ //If the password entered has met all of the regexes
								root.changeMeter('strong');
							} else {
								root.changeMeter('medium');
							}
						} else {
							root.changeMeter('weak');								  
						}
					} else {
						root.changeMeter('poor');
					}					
				}
			});
		};
		this.changeMeter = function(strength){
			var widths = {
					poor:'25%',
					weak:'33%',
					medium:'75%',
					strong:'100%'
			};
			root.vars.metervalue.css('width',widths[strength]);
			root.vars.meter[0].className = root.vars[strength+'Class'];
			if(root.vars.useText) {
				var constant = 'PLG_USER_PASSWORDSTRENGTH_TEXT_'+(strength.toUpperCase());
				root.vars.metertext.text(Joomla.JText._(constant));
			}
		};
        this.element = function (raw) {
            return (raw !== undefined && raw === true) ? root.vars.container : $(root.vars.container);
        };
        this.uid = function () {
            return root._uid().replace(/[/,'').replace(/]/, "").replace(/:/, "");
        };
        this._uid = function () {
            if (root.element().attr("id")) {
                return root.element().attr("id");
            }
            if (root.element().attr("name")) {
                return root.element().attr("name");
            }
            var a = "";
            if (root.element(true).form.id) {
                a = root.element(true).form.id;
            }
            if (!a && root.element(true).form.name) {
                a = root.element(true).form.name;
            }
            return a + root.element().index();
        };
		construct(options);
	};
    $.fn.PasswordStrength = function (o) {
        // initializing
        var args = arguments;
        var o = o || {'container': ''};
        return this.each(function () {
            // load the saved object
            var api = $.data(this, 'PasswordStrength');
            // create and save the object if it does not exist
            if (!api) {
                o.container = this;
                api = new PasswordStrength(o);
                $.data(this, 'PasswordStrength', api);
            }
            if (typeof api[o] === 'function') {
                if (args[0] === o)
                    delete args[0];
                api[o].bind(api);
                var parameters = Array.prototype.slice.call(args, 1);
                return api[o].apply(api, parameters);
            }
            return api;
        });
    };
})(jQuery);
// Polyfill for Object.assign in IE
if (typeof Object.assign !== 'function') {
    // Must be writable: true, enumerable: false, configurable: true
    Object.defineProperty(Object, "assign", {
        value: function assign(target, varArgs) { // .length of function is 2
            'use strict';
            if (target === null) { // TypeError if undefined or null
                throw new TypeError('Cannot convert undefined or null to object');
            }

            var to = Object(target);

            for (var index = 1; index < arguments.length; index++) {
                var nextSource = arguments[index];

                if (nextSource !== null) { // Skip over if undefined or null
                    for (var nextKey in nextSource) {
                        // Avoid bugs when hasOwnProperty is shadowed
                        if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                            to[nextKey] = nextSource[nextKey];
                        }
                    }
                }
            }
            return to;
        },
        writable: true,
        configurable: true
    });
}
